from datetime import datetime
from pydantic.main import BaseModel
from typing import Optional
from pianosdk.publisher.models.app import App
from typing import List

class UserProviderConfiguration(BaseModel):
    user_provider_configuration_id: Optional[str]
    app: Optional['App']
    source: Optional[str]
    title: Optional[str]
    app_id: Optional[str]
    app_name: Optional[str]
    client_secret: Optional[str]
    client_id: Optional[str]
    type_name: Optional[str]
    reset_password_client_id: Optional[str]
    reset_password_flow: Optional[str]
    reset_password_flow_version: Optional[str]
    reset_password_locale: Optional[str]
    reset_password_redirect_uri: Optional[str]
    reset_password_form: Optional[str]
    api_version: Optional[str]
    endpoint: Optional[str]
    api_key: Optional[str]
    api_secret: Optional[str]
    auth_key: Optional[str]
    site_code: Optional[str]
    reset_password_template_name: Optional[str]
    reset_password_sender: Optional[str]
    reset_password_logo_url: Optional[str]
    reset_password_brand_name: Optional[str]
    reset_password_login_url: Optional[str]
    reset_password_site_base_url: Optional[str]
    reset_password_privacy_policy_url: Optional[str]
    reset_password_user_agreement_url: Optional[str]
    is_disabled: Optional[bool]
    is_editable: Optional[bool]
    secret_key: Optional[str]
    user_key: Optional[str]
    gigya_datacenter_url: Optional[str]
    gigya_passwordless_captcha_enabled: Optional[bool]
    gigya_passwordless_login_on_gift_redemption_enabled: Optional[bool]
    shared_secret: Optional[str]
    reset_password_landing_page_url: Optional[str]
    passwordless_magic_link_url: Optional[str]
    oauth_client_secret: Optional[str]
    token_expiration_time: Optional[int]
    password_reset_and_sign_in_link_expiration_time_in_hours: Optional[int]
    deployment_host: Optional[str]
    password_minimal_length: Optional[int]
    password_has_mixed_case: Optional[bool]
    password_has_alphanumeric: Optional[bool]
    password_has_special_characters: Optional[bool]
    password_has_no_email: Optional[bool]
    use_captcha: Optional[bool]
    captcha_version: Optional[str]
    captcha_screen: Optional[str]
    captcha3_site_key: Optional[str]
    captcha3_secret_key: Optional[str]
    reset_password_captcha: Optional[bool]
    authentication_attempts_to_show_captcha: Optional[int]
    message_login_failed: Optional[str]
    social_callback_url: Optional[str]
    social_settings: Optional[str]
    piano_id_main_settings: Optional[str]
    require_first_and_last_names: Optional[bool]
    override_shared_secret_for_global_mode: Optional[bool]
    disable_custom_fields_user_mining: Optional[bool]
    disable_custom_fields_counters: Optional[bool]
    client_custom_fields_validation: Optional[bool]
    extend_expired_access_enabled: Optional[bool]
    passwordless_login_enabled: Optional[bool]
    redirect_uri_whitelist: Optional[List[str]]
    redirect_uri_whitelist_confirmed: Optional[bool]
    external_identity_providers: Optional[str]


UserProviderConfiguration.update_forward_refs()
